Subject: bug#3540: Please reserve a ctrl-key combination for interoperability

From: Marcin Borkowski <[email-masked]>
Date: Sun, 06 Oct 2019 21:39:50 +0200

On 2019-10-06, at 18:10, Drew Adams <[email-masked]> wrote:

>> As a partial solution, the manual *might* suggest to use C-z for that,
>> especially that is is bounded to a 99.99% useless command by default
>> (and using e.g. screen or tmux makes it 100% useless).
>
> No, please don't do that.  IMO:
>
> `C-z' is better used by users and libraries as a
> _prefix key_ (by users who are willing to forego
> the default binding).

Actually, that's what I do in my config.  (Is there anyone who actually
wants C-z's default binding???)

> The manual should not suggest that users bind any
> particular keys.  It's OK for a 3rd-party library
> to suggest key bindings.  It's not good for Emacs
> itself to do that.

I'm not sure I agree.  I'd welcome a list of bindings like C-z or M-o
which do nothing useful by default.  (In fact, I compiled such a list
myself - http://mbork.pl/2019-03-18_Free_Emacs_key_bindings - but I'm
not very happy with it.)

> 3rd-party libraries are opt-in by users.  Using
> one is like adding its feature/code to your init
> file - it's a user choice.
>
> The same isn't true of much of the code distributed
> by Emacs.  And even when a distributed library (e.g.
> `dired-x.el') is opt-in, Emacs should not suggest
> bindings for its commands.  "Suggestion" by Emacs
> is sometimes mistakenly taken by users as a "rule"
> or a convention.

That's why it should be made clear that it's a suggestion, like:

"Many users find some commands not useful for them at all.  They might
want to rebind their keys to ones that they use frequently."

> There's no good reason for Emacs to suggest that
> users use `C-z' for anything particular.

On the contrary, there is: the meaning of C-z is "I want to leave Emacs
for a moment and be able to come back".  If you use screen or tmux, you
express the same wish by pressing a combo starting with the prefix key.

Of course, I'm not insisting at all - just suggesting.

Best,

--
Marcin Borkowski
http://mbork.pl